      SUBROUTINE QSS2D(RINT,A,B,F,N,EPS,K,IND,R,IERR)
         INTEGER IERR,IND,K,N
         DOUBLE PRECISION A,B,EPS,R,RINT
         DIMENSION IND(N),R(N,3),RINT(N)
         EXTERNAL UTQS12
         INTEGER I,J,J1,K1,K2
         DOUBLE PRECISION E,H,H1,S
       IERR = 0
       DO 10 I = 1, N
          R(I,3) = 0.D0
          IND(I) = 0
   10  CONTINUE
       K1 = K
       IF (K .LE. 0) K1 = 1
       H = (B - A)/K1*.5D0
       CALL F(A,RINT,IND)
       CALL F(B,R,IND)
       DO 20 I = 1, N
          R(I,2) = (RINT(I) + R(I,1))*H
          RINT(I) = R(I,2)/3.D0
   20  CONTINUE
       K1 = K1 + K1 - 1
       J1 = -1
       DO 40 J = 1, K1
          CALL F(A + J*H,R,IND)
          J1 = -1*J1
          DO 30 I = 1, N
             RINT(I) = RINT(I) + (3.D0 + J1)*R(I,1)*H/3.D0
             R(I,2) = R(I,2) + R(I,1)*2.D0*H
   30     CONTINUE
   40  CONTINUE
       IF (EPS .LE. 0.D0) GO TO 90
          K1 = K1 + 1
   50  CONTINUE
       H1 = H*.5D0
       DO 70 J = 1, K1
          CALL F(A + (2.D0*J - 1.D0)*H1,R,IND)
          DO 60 I = 1, N
             R(I,3) = R(I,3) + R(I,1)
   60     CONTINUE
   70  CONTINUE
       K2 = 1
       DO 80 I = 1, N
          IF (IND(I) .GT. 0) GO TO 80
             S = (R(I,2) + 4.D0*H*R(I,3))/6.D0
             E = DABS(RINT(I) - S)/(1.D0 + DABS(S))
             RINT(I) = S
             IF (E .LE. EPS) IND(I) = K1/2
             R(I,2) = .5D0*R(I,2) + R(I,3)*H
             R(I,3) = 0.D0
             IF (IND(I) .EQ. 0) K2 = 0
   80  CONTINUE
       IF (K2 .GT. 0) GO TO 90
          K1 = K1 + K1
          H = H*.5D0
          IF (K1 .LE. 1048576) GO TO 50
             IERR = 65
             CALL UTQS12(IERR,9)
   90     RETURN
      END
